/******************************************************************************
Connection.java

CVS Information:

  $Source: /homes/dsl/Master/cif/CIF-Comm-Java-Current/libraries/cif/comm/Factory.java,v $
  $Date: 1998/10/13 20:25:45 $
  $Revision: 1.3 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

package cif.comm;

import cif.toolkit.*;


/**
 * A group of static methods used to construct CIF objects.
 */
public class Factory
{
    public static
    Connection
    get_Connection(
	String					url)
    throws
	Object_Active_Exception,
	Bad_Parameter_Exception,
	Comm_Inactive_Exception,
	Comm_Failure_Exception,
	InterruptedException
    {
	try
	{
	    return l_get_Connection(url,
				    new Connection_Properties(),
				    new Timeout(Timeout.INFINITY));
	}
	catch (Timeout_Expired_Exception e)
	{
	    throw new Internal_Error(
		"Factory.get_Connection() caught an unexpected " +
		"Timeout_Expired_Exception");
	}
    }
    
    public static
    Connection
    get_Connection(
	String					url,
	long					timeout)
    throws
	Object_Active_Exception,
	Timeout_Expired_Exception,
	Bad_Parameter_Exception,
	Comm_Inactive_Exception,
	Comm_Failure_Exception,
	InterruptedException
    {
	return l_get_Connection(url,
				new Connection_Properties(),
				new Timeout(timeout));
    }

    public static
    Connection
    get_Connection(
	String					url,
	Timeout					timeout)
    throws
	Object_Active_Exception,
	Timeout_Expired_Exception,
	Bad_Parameter_Exception,
	Comm_Inactive_Exception,
	Comm_Failure_Exception,
	InterruptedException
    {
	return l_get_Connection(url,
				new Connection_Properties(),
				timeout);
    }

    public static
    Connection
    get_Connection(
	String					url,
	Connection_Properties			properties)
    throws
	Object_Active_Exception,
	Bad_Parameter_Exception,
	Comm_Inactive_Exception,
	Comm_Failure_Exception,
	InterruptedException
    {
	try
	{
	    return l_get_Connection(url,
				    properties,
				    new Timeout(Timeout.INFINITY));
	}
	catch (Timeout_Expired_Exception e)
	{
	    throw new Internal_Error(
		"Factory.get_Connection() caught an unexpected " +
		"Timeout_Expired_Exception");
	}
    }
    
    public static
    Connection
    get_Connection(
	String					url,
	Connection_Properties			properties,
	long					timeout)
    throws
	Object_Active_Exception,
	Timeout_Expired_Exception,
	Bad_Parameter_Exception,
	Comm_Inactive_Exception,
	Comm_Failure_Exception,
	InterruptedException
    {
	return l_get_Connection(url,
				properties,
				new Timeout(timeout));
    }

    public static
    Connection
    get_Connection(
	String					url,
	Connection_Properties			properties,
	Timeout					timeout)
    throws
	Object_Active_Exception,
	Timeout_Expired_Exception,
	Bad_Parameter_Exception,
	Comm_Inactive_Exception,
	Comm_Failure_Exception,
	InterruptedException
    {
	return l_get_Connection(url,
				properties,
				timeout);
    }

    public static
    Listener
    get_Listener(
	String					url)
    throws
	Object_Active_Exception,
	Bad_Parameter_Exception,
	Comm_Inactive_Exception,
	Comm_Failure_Exception
    {
	return l_get_Listener(url, new Listener_Properties());
    }
    
    public static
    Listener
    get_Listener(
	String					url,
	Listener_Properties			properties)
    throws
	Object_Active_Exception,
	Bad_Parameter_Exception,
	Comm_Inactive_Exception,
	Comm_Failure_Exception
    {
	return l_get_Listener(url, properties);
    }
    
    private static
    Connection
    l_get_Connection(
	String					url_string,
	Connection_Properties			properties,
	Timeout					timeout)
    throws
	Object_Active_Exception,
	Timeout_Expired_Exception,
	Bad_Parameter_Exception,
	Comm_Inactive_Exception,
	Comm_Failure_Exception,
	InterruptedException
    {
	URL					url;
	I_Connection				conn;
	
	
	url = new URL(url_string);

	conn = null;
	
	if (url.get_Protocol().compareTo(Comm.TCP_URL_SCHEME) == 0)
	{
	    conn = new I_Connection_TCP();
	}
	else
	{
	    throw new Bad_Parameter_Exception(
		1, "unrecognized protocol in URL");
	}

	conn.activate(url, properties, timeout);
		      
	return conn;
    }

    private static
    Listener
    l_get_Listener(
	String					url_string,
	Listener_Properties			properties)
    throws
	Object_Active_Exception,
	Bad_Parameter_Exception,
	Comm_Inactive_Exception,
	Comm_Failure_Exception
    {
	URL					url;
	I_Listener				listener;
	
	
	url = new URL(url_string);

	listener = null;
	
	if (url.get_Protocol().compareTo(Comm.TCP_URL_SCHEME) == 0)
	{
	    listener = new I_Listener_TCP();
	}
	else
	{
	    throw new Bad_Parameter_Exception(
		1, "unrecognized protocol in URL");
	}

	listener.activate(url, properties);
		      
	return listener;
    }
}
