/******************************************************************************
I_Endpoint_Properties.java

CVS Information:

  $Source: /homes/dsl/Master/cif/CIF-Comm-Java-Current/libraries/cif/comm/I_Endpoint_Properties.java,v $
  $Date: 1998/10/13 06:33:47 $
  $Revision: 1.2 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

package cif.comm;

import nexus.*;
import cif.toolkit.*;

/**
 * I_Endpoint_Properties defines properties for an NSML endpoint.  These
 * properties include the protocol used for communication, remote attach
 * information, and an event listener which will recieve connection request
 * events.
 */
class I_Endpoint_Properties
extends
    I_Properties
{
    public
    I_Endpoint_Properties()
    {
	l_proto_info = new TcpInfo();
	l_attach_enabled = false;
	l_attach_port = 0;
    }
	
    public
    void
    set_Protocol(
	nexus.ProtoInfo				proto_info)
    {
	l_proto_info = proto_info;
    }

    public
    nexus.ProtoInfo
    get_Protocol()
    {
	return l_proto_info;
    }

    public
    void
    enable_Attach()
    {
	l_attach_enabled = true;
    }

    public
    void
    disable_Attach()
    {
	l_attach_enabled = false;
    }

    public
    boolean
    is_Attach_Enabled()
    {
	return l_attach_enabled;
    }

    public
    void
    set_Attach_Port(
	int					port)
    throws
	Bad_Parameter_Exception
    {
	if (port < 0 || port > 65535)
	{
	    throw new Bad_Parameter_Exception(
		1, "port ID must be between 0 and 65535");
	}
	    
	l_attach_port = port;
    }
	
    public
    int
    get_Attach_Port()
    {
	return l_attach_port;
    }

    private nexus.ProtoInfo			l_proto_info;
    private boolean				l_attach_enabled;
    private int					l_attach_port;	
}
