package cif.comm;

import cif.toolkit.*;
import nexus.*;

class Test_NSML
{
    public
    Test_NSML()
    {
	i_ep = new I_Endpoint();
	i_sp = new I_Startpoint();
    }

    public
    void
    run_Test(
	int					msg_cnt,
	Timeout					timeout)
    throws
	java.lang.Exception
    {
	char []					msg_buf;
	int					msg_len;
	int					cnt;
	Nexus					nx;

	nx = Comm.acquire_Nexus();
	
	i_ep.enable_Event_Notification();
	System.out.println("endpoint.enable_Event_Notificaiton(): completed");

	for (cnt = 0; cnt < msg_cnt; cnt ++)
	{
	    PutBuffer				nx_buf;
	    int					nx_buf_sz;
	    String				msg_string;

	    msg_string = "test message " + cnt;
	    msg_len = msg_string.length();

	    msg_buf = new char[msg_len];
	    msg_string.getChars(0, msg_len, msg_buf, 0);

	    nx_buf_sz = nx.sizeof_int(1) + nx.sizeof_char(msg_len);
	    nx_buf = nx.buffer_init(nx_buf_sz, 0);
	    nx_buf.put_int(msg_len);
	    nx_buf.put_char(msg_buf, 0, msg_len);
	    System.out.println("nx_buf.put(): completed");

	    i_sp.send(nx_buf);
	    System.out.println("startpoint.send(): completed");

	    Thread.yield();
	}

	for (cnt = 0; cnt < msg_cnt; cnt ++)
	{
	    GetBuffer				nx_buf;

	    nx_buf = i_ep.receive(timeout);
	    System.out.println("endpoint.receive(): completed");
			       
	    msg_len = nx_buf.get_int();

	    msg_buf = new char[msg_len];
	    nx_buf.get_char(msg_buf, 0, msg_len);
	    
	    System.out.println("Message " + cnt + ": " + msg_buf);
	}

	Comm.release_Nexus();
    }

    protected I_Endpoint			i_ep;
    protected I_Startpoint			i_sp;
}
