package cif.comm;

import cif.toolkit.*;


class Test_NSML_Bind
extends
    Test_NSML
implements
    Event_Listener
{
    public
    Test_NSML_Bind()
    {
	super();
    }

    public
    void
    run_Test(
	int					msg_cnt,
	Timeout					timeout)
    throws
	java.lang.Exception
    {
	
	I_Endpoint_Properties			properties;
	String					host;
	int					port;

	properties = new I_Endpoint_Properties();
	properties.set_Event_Listener(this);

	i_ep.activate(properties);
	System.out.println("endpoint.activate(): completed");

	i_sp.activate(i_ep);
	System.out.println("startpoint.activate(): completed");

	super.run_Test(msg_cnt, timeout);
	
	i_sp.deactivate();
	System.out.println("startpoint.deactivate(): completed");

    	i_ep.deactivate();
	System.out.println("endpoint.deactivate(): completed");
    }

    public
    void
    handle_Event(
	Event					event)
    {
	System.out.println("Test_NSML_Bind.handle_Event(): called");
    }

    public static final
    void
    main(
	String []				args)
    throws
	Exception    
    {
	Test_NSML_Bind				test;
	int					msg_cnt;
	Timeout					timeout;

	if (args.length < 1 || args.length > 2)
	{
	    System.err.println("usage: Test_NSML_Bind <count> [timeout]");
	    System.exit(1);
	}

	msg_cnt = Integer.parseInt(args[0]);
	if (args.length == 2)
	{
	    timeout = new Timeout(Integer.parseInt(args[0]));
	}
	else
	{
	    timeout = new Timeout(Timeout.INFINITY);
	}
	
	Comm.activate();

	test = new Test_NSML_Bind();
	test.run_Test(msg_cnt, timeout);

	Comm.deactivate();
    }
}
