/******************************************************************************
Sync_Queue.java

CVS Information:

  $Source: /homes/dsl/Master/cif/CIF-Comm-Java-Current/libraries/cif/toolkit/Sync_Queue.java,v $
  $Date: 1998/10/13 22:57:23 $
  $Revision: 1.1 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

package cif.toolkit;


/**
 * Generic FIFO queue which is used internally by CIF.
 */
public class Sync_Queue
{
    public
    Sync_Queue()
    {
	l_q = new Queue();
	l_waiting_cnt = 0;
    }


    public synchronized
    void
    enqueue(
	Object					data)
    {
	l_q.enqueue(data);
	if (l_waiting_cnt > 0)
	{
	    notify();
	}
    }


    public
    Object
    dequeue()
    throws
	InterruptedException
    {
	try
	{
	    return dequeue(new Timeout(Timeout.INFINITY));
	}
	catch (Timeout_Expired_Exception e)
	{
	    throw new Internal_Error(
		"cif.toolkit.Sync_Queue.dequeue(): " +
		"caught an unexcepted Timeout_Expired_Exception");
	}
    }
    

    public
    Object
    dequeue(
	long					timeout)
    throws
	Timeout_Expired_Exception,
	InterruptedException
    {
	return dequeue(new Timeout(timeout));
    }
    

    public synchronized
    Object
    dequeue(
	Timeout					timeout)
    throws
	Timeout_Expired_Exception,
	InterruptedException
    {
	if (l_q.empty())
	{
	    while(true)
	    {
		try
		{
		    l_waiting_cnt++;
		
		    if (timeout.is_Infinity())
		    {
			wait();
		    }
		    else
		    {
			wait(timeout.get(), 1);
		    }
		}
		finally
		{
		    l_waiting_cnt--;
		}

		if (!l_q.empty())
		{
		    break;
		}
	    
		if (timeout.is_Expired())
		{
		    throw new Timeout_Expired_Exception();
		}
	    }
	}
	
	return l_q.dequeue();
    }

    private Queue				l_q;
    private int					l_waiting_cnt;
}

